#!/bin/bash

BIN_DIR=bin
SRC=src/

case $1 in
  -compile)
    case $2 in
     -ext)
        java -jar lib/abc-ja-exts-complete.jar -ext $3 -sourceroots $SRC -d $BIN_DIR
        ;;
     *)
        java -jar lib/abc-ja-exts-complete.jar -sourceroots $SRC -d $BIN_DIR
        ;;
    esac
    ;;
  -run)
    if [ -d "$BIN_DIR" ]
     then
      cd $BIN_DIR
      java -cp .:../lib/abc-runtime.jar certrevsim.Simulator 20 200 90 5 60 1 1
    else
      echo "you need to compile the project first"
    fi
    ;;
  *)
    echo "-compile : to compile without any abc extension"
    echo "-compile -ext abc.ja.jpi : to compile with jpi abc extension"
    echo "-run : to run LawOfDemeter"
esac


