package lawOfDemeter;

public aspect AnyAspect {
	  public pointcut scope(): !within(lawOfDemeter..*) 
	    && !cflow(withincode(* lawOfDemeter..*(..)));
	  
	  public pointcut StaticInitialization(): scope()
	    && staticinitialization(*);
	  
	  public pointcut MethodCallSite(): scope()
	    && call(* *(..));
	  
	  public pointcut ConstructorCall(): scope()
	    && call(*.new (..));
	  
	  public pointcut MethodExecution(): scope()
	    && execution(* *(..)); 
	  
	  public pointcut ConstructorExecution(): scope()
	    && execution(*.new (..));
	  
	  public pointcut Execution(): 
	    ConstructorExecution() || MethodExecution(); 
	  
	  public pointcut MethodCall(Object thiz,
	    Object targt): MethodCallSite()
	    && this(thiz) 
	    && target(targt);
	  
	  public pointcut SelfCall(Object thiz,
	    Object targt): MethodCall(thiz,targt)
	    && if(thiz == targt);
	  
	  public pointcut StaticCall(): scope() 
	    && call(static * *(..));
	  
	  public pointcut Set(Object value): scope() 
	    && set(* *.*) && args(value); 
	  
	  public pointcut Initialization(): scope()
	    && initialization(*.new(..));
}
