package lawOfDemeter.objectform;

import lawOfDemeter.AnyAspect;
import org.aspectj.lang.JoinPoint;

import java.io.IOException;
import java.util.*;
import certrevsim.DeltaRevocationInfo;
import certrevsim.Repository;
import certrevsim.Simulator.*;
import jsim.queue.PriorityQueue;
import jsim.queue.Queue;

import certrevsim.*;
import jsim.*;
import jsim.event.*;
import jsim.queue.*;
import java.io.PrintStream;

import joinpointinterfaces.*;

/**
 * @authors David H. Lorenz and Pengcheng Wu
 * @version 0.7, 12/01/02
 */
/*** THIS MUST BE LINE 9 ***/
aspect Check {
	
	exhibits PrintStream IgnoreTargets() :
		get(static PrintStream java..*.*);
	
  private pointcut IgnoreCalls():
    call(* java..*.*(..));

  private pointcut IgnoreTargets1():
    get(static * java..*.*);

//  after() returning(Object o):IgnoreTargets1() {
//    ignoredTargets.put(o,o);
//  }
  
	after IgnoreTargets() returning(PrintStream o){
		ignoredTargets.put(o, o);
	}  

	<R> after MethodCall(R thiz, R targt){
	    if (!ignoredTargets.containsKey(targt) && 
	    	      !Pertarget.aspectOf(thiz).contains(targt)){ 
	    	objectViolations.put(thisJoinPointStaticPart, thisJoinPointStaticPart);
	    }				
	}

	after MainExecution(){
		Collection c = objectViolations.values();
		for (Iterator i = c.iterator(); i.hasNext(); )
		{ 
			JoinPoint.StaticPart jp = (JoinPoint.StaticPart) i.next();
			System.out.println(
					" !! LoD Object Violation !! " + jp + at(jp)); 
		}	  
	}

	private String at(JoinPoint.StaticPart jp) {
		return " at " + jp.getSourceLocation().getFileName()
			+ ":" + jp.getSourceLocation().getLine();
	}

	private IdentityHashMap 
		ignoredTargets = new IdentityHashMap();

	private IdentityHashMap 
		objectViolations = new IdentityHashMap();

}
